Attribute VB_Name = "modFormatMsg"
' ************************************************************
' Copyright  1995-2001 Slightly Tilted Software
' All rights reserved
' You're absolutely free to use these resources within your
'     own applications, but you may not redistribute them
'     (as source) in any manner whatsoever, whether for profit
'     or not.
' The only legitimate source for the original source code is
'     at the VBPJ site and my own web site at:
'     http://www.SlightlyTiltedSoftware.com
' ************************************************************

' *************************************************
' * With special thanks to Karl Peterson and his  *
' * contacts at Microsoft for the TranslateArray  *
' * function.  It's a kludge, and it's ugly, but  *
' * hey, it works!
' *************************************************
Option Explicit

' -------------------------------------------------
' Used by FormatMessage function
' -------------------------------------------------
Private Const FORMAT_MESSAGE_ALLOCATE_BUFFER As Long = &H100&
Private Const FORMAT_MESSAGE_IGNORE_INSERTS  As Long = &H200&
Private Const FORMAT_MESSAGE_FROM_STRING     As Long = &H400&
Private Const FORMAT_MESSAGE_FROM_HMODULE    As Long = &H800&
Private Const FORMAT_MESSAGE_FROM_SYSTEM     As Long = &H1000&
Private Const FORMAT_MESSAGE_ARGUMENT_ARRAY  As Long = &H2000&
Private Const FORMAT_MESSAGE_MAX_WIDTH_MASK  As Long = &HFF&

Public Declare Function FormatMessage _
   Lib "Kernel32" Alias "FormatMessageA" _
   (ByVal dwFlags As Long, lpSource As Any, _
    ByVal dwMessageId As Long, ByVal dwLanguageId As Long, _
    ByVal lpBuffer As String, ByVal nSize As Long, _
    Arguments As Any) As Long

Public Type FmtMsgArrayType
   s1       As String
   s2       As String
   s3       As String
   s4       As String
   s5       As String
   s6       As String
   s7       As String
   s8       As String
   s9       As String
   s10      As String
   s11      As String
   s12      As String
   s13      As String
   s14      As String
   s15      As String
   s16      As String
   s17      As String
   s18      As String
   s19      As String
   s20      As String
   s21      As String
   s22      As String
   s23      As String
   s24      As String
   s25      As String
   s26      As String
   s27      As String
   s28      As String
   s29      As String
   s30      As String
   s31      As String
   s32      As String
   s33      As String
   s34      As String
   s35      As String
   s36      As String
   s37      As String
   s38      As String
   s39      As String
   s40      As String
   s41      As String
   s42      As String
   s43      As String
   s44      As String
   s45      As String
   s46      As String
   s47      As String
   s48      As String
   s49      As String
   s50      As String
   s51      As String
   s52      As String
   s53      As String
   s54      As String
   s55      As String
   s56      As String
   s57      As String
   s58      As String
   s59      As String
   s60      As String
   s61      As String
   s62      As String
   s63      As String
   s64      As String
   s65      As String
   s66      As String
   s67      As String
   s68      As String
   s69      As String
   s70      As String
   s71      As String
   s72      As String
   s73      As String
   s74      As String
   s75      As String
   s76      As String
   s77      As String
   s78      As String
   s79      As String
   s80      As String
   s81      As String
   s82      As String
   s83      As String
   s84      As String
   s85      As String
   s86      As String
   s87      As String
   s88      As String
   s89      As String
   s90      As String
   s91      As String
   s92      As String
   s93      As String
   s94      As String
   s95      As String
   s96      As String
   s97      As String
   s98      As String
   s99      As String
End Type

' *******************************************************
' Routine Name : (PUBLIC in MODULE) Function TranslateArray
' Written By   : L.J  Johnson
' Programmer   : L.J  Johnson [Slightly Tilted Software]
' Date Writen  : 05/30/2001 -- 10:51:35
' Inputs       : ByRef xi_astrArgs():String -
'              : ByRef xio_UDT:FmtMsgArrayType -
' Outputs      : LONG: Count of array elements
' Description  : Translate a passed array into a type variable
'              :     that can be used by the FormatMessage
'              :     API call
' *******************************************************
Public Function TranslateArray(ByRef xi_astrArgs() As String, _
                               ByRef xio_UDT As FmtMsgArrayType) As Long
On Error Resume Next                   ' Don't accept an error here
   Dim p_lngLoop                       As Long
   Dim p_lngCounter                    As Long
   Dim p_lngLower                      As Long
   Dim p_lngUpper                      As Long
   
   p_lngLower = LBound(xi_astrArgs)
   p_lngUpper = UBound(xi_astrArgs)
   
   If p_lngLower < 0 Then
      Exit Function
   ElseIf p_lngLower > p_lngUpper Then
      Exit Function
   End If
   
   For p_lngLoop = p_lngLower To p_lngUpper
      p_lngCounter = p_lngCounter + 1
      Select Case p_lngCounter
         Case 1: xio_UDT.s1 = xi_astrArgs(p_lngLoop)
         Case 2: xio_UDT.s2 = xi_astrArgs(p_lngLoop)
         Case 3: xio_UDT.s3 = xi_astrArgs(p_lngLoop)
         Case 4: xio_UDT.s4 = xi_astrArgs(p_lngLoop)
         Case 5: xio_UDT.s5 = xi_astrArgs(p_lngLoop)
         Case 6: xio_UDT.s6 = xi_astrArgs(p_lngLoop)
         Case 7: xio_UDT.s7 = xi_astrArgs(p_lngLoop)
         Case 8: xio_UDT.s8 = xi_astrArgs(p_lngLoop)
         Case 9: xio_UDT.s9 = xi_astrArgs(p_lngLoop)
         Case 10: xio_UDT.s10 = xi_astrArgs(p_lngLoop)
         Case 11: xio_UDT.s11 = xi_astrArgs(p_lngLoop)
         Case 12: xio_UDT.s12 = xi_astrArgs(p_lngLoop)
         Case 13: xio_UDT.s13 = xi_astrArgs(p_lngLoop)
         Case 14: xio_UDT.s14 = xi_astrArgs(p_lngLoop)
         Case 15: xio_UDT.s15 = xi_astrArgs(p_lngLoop)
         Case 16: xio_UDT.s16 = xi_astrArgs(p_lngLoop)
         Case 17: xio_UDT.s17 = xi_astrArgs(p_lngLoop)
         Case 18: xio_UDT.s18 = xi_astrArgs(p_lngLoop)
         Case 19: xio_UDT.s19 = xi_astrArgs(p_lngLoop)
         Case 20: xio_UDT.s20 = xi_astrArgs(p_lngLoop)
         Case 21: xio_UDT.s21 = xi_astrArgs(p_lngLoop)
         Case 22: xio_UDT.s22 = xi_astrArgs(p_lngLoop)
         Case 23: xio_UDT.s23 = xi_astrArgs(p_lngLoop)
         Case 24: xio_UDT.s24 = xi_astrArgs(p_lngLoop)
         Case 25: xio_UDT.s25 = xi_astrArgs(p_lngLoop)
         Case 26: xio_UDT.s26 = xi_astrArgs(p_lngLoop)
         Case 27: xio_UDT.s27 = xi_astrArgs(p_lngLoop)
         Case 28: xio_UDT.s28 = xi_astrArgs(p_lngLoop)
         Case 29: xio_UDT.s29 = xi_astrArgs(p_lngLoop)
         Case 30: xio_UDT.s30 = xi_astrArgs(p_lngLoop)
         Case 31: xio_UDT.s31 = xi_astrArgs(p_lngLoop)
         Case 32: xio_UDT.s32 = xi_astrArgs(p_lngLoop)
         Case 33: xio_UDT.s33 = xi_astrArgs(p_lngLoop)
         Case 34: xio_UDT.s34 = xi_astrArgs(p_lngLoop)
         Case 35: xio_UDT.s35 = xi_astrArgs(p_lngLoop)
         Case 36: xio_UDT.s36 = xi_astrArgs(p_lngLoop)
         Case 37: xio_UDT.s37 = xi_astrArgs(p_lngLoop)
         Case 38: xio_UDT.s38 = xi_astrArgs(p_lngLoop)
         Case 39: xio_UDT.s39 = xi_astrArgs(p_lngLoop)
         Case 40: xio_UDT.s40 = xi_astrArgs(p_lngLoop)
         Case 41: xio_UDT.s41 = xi_astrArgs(p_lngLoop)
         Case 42: xio_UDT.s42 = xi_astrArgs(p_lngLoop)
         Case 43: xio_UDT.s43 = xi_astrArgs(p_lngLoop)
         Case 44: xio_UDT.s44 = xi_astrArgs(p_lngLoop)
         Case 45: xio_UDT.s45 = xi_astrArgs(p_lngLoop)
         Case 46: xio_UDT.s46 = xi_astrArgs(p_lngLoop)
         Case 47: xio_UDT.s47 = xi_astrArgs(p_lngLoop)
         Case 48: xio_UDT.s48 = xi_astrArgs(p_lngLoop)
         Case 49: xio_UDT.s49 = xi_astrArgs(p_lngLoop)
         Case 50: xio_UDT.s50 = xi_astrArgs(p_lngLoop)
         Case 51: xio_UDT.s51 = xi_astrArgs(p_lngLoop)
         Case 52: xio_UDT.s52 = xi_astrArgs(p_lngLoop)
         Case 53: xio_UDT.s53 = xi_astrArgs(p_lngLoop)
         Case 54: xio_UDT.s54 = xi_astrArgs(p_lngLoop)
         Case 55: xio_UDT.s55 = xi_astrArgs(p_lngLoop)
         Case 56: xio_UDT.s56 = xi_astrArgs(p_lngLoop)
         Case 57: xio_UDT.s57 = xi_astrArgs(p_lngLoop)
         Case 58: xio_UDT.s58 = xi_astrArgs(p_lngLoop)
         Case 59: xio_UDT.s59 = xi_astrArgs(p_lngLoop)
         Case 60: xio_UDT.s60 = xi_astrArgs(p_lngLoop)
         Case 61: xio_UDT.s61 = xi_astrArgs(p_lngLoop)
         Case 62: xio_UDT.s62 = xi_astrArgs(p_lngLoop)
         Case 63: xio_UDT.s63 = xi_astrArgs(p_lngLoop)
         Case 64: xio_UDT.s64 = xi_astrArgs(p_lngLoop)
         Case 65: xio_UDT.s65 = xi_astrArgs(p_lngLoop)
         Case 66: xio_UDT.s66 = xi_astrArgs(p_lngLoop)
         Case 67: xio_UDT.s67 = xi_astrArgs(p_lngLoop)
         Case 68: xio_UDT.s68 = xi_astrArgs(p_lngLoop)
         Case 69: xio_UDT.s69 = xi_astrArgs(p_lngLoop)
         Case 70: xio_UDT.s70 = xi_astrArgs(p_lngLoop)
         Case 71: xio_UDT.s71 = xi_astrArgs(p_lngLoop)
         Case 72: xio_UDT.s72 = xi_astrArgs(p_lngLoop)
         Case 73: xio_UDT.s73 = xi_astrArgs(p_lngLoop)
         Case 74: xio_UDT.s74 = xi_astrArgs(p_lngLoop)
         Case 75: xio_UDT.s75 = xi_astrArgs(p_lngLoop)
         Case 76: xio_UDT.s76 = xi_astrArgs(p_lngLoop)
         Case 77: xio_UDT.s77 = xi_astrArgs(p_lngLoop)
         Case 78: xio_UDT.s78 = xi_astrArgs(p_lngLoop)
         Case 79: xio_UDT.s79 = xi_astrArgs(p_lngLoop)
         Case 80: xio_UDT.s80 = xi_astrArgs(p_lngLoop)
         Case 81: xio_UDT.s81 = xi_astrArgs(p_lngLoop)
         Case 82: xio_UDT.s82 = xi_astrArgs(p_lngLoop)
         Case 83: xio_UDT.s83 = xi_astrArgs(p_lngLoop)
         Case 84: xio_UDT.s84 = xi_astrArgs(p_lngLoop)
         Case 85: xio_UDT.s85 = xi_astrArgs(p_lngLoop)
         Case 86: xio_UDT.s86 = xi_astrArgs(p_lngLoop)
         Case 87: xio_UDT.s87 = xi_astrArgs(p_lngLoop)
         Case 88: xio_UDT.s88 = xi_astrArgs(p_lngLoop)
         Case 89: xio_UDT.s89 = xi_astrArgs(p_lngLoop)
         Case 90: xio_UDT.s90 = xi_astrArgs(p_lngLoop)
         Case 91: xio_UDT.s91 = xi_astrArgs(p_lngLoop)
         Case 92: xio_UDT.s92 = xi_astrArgs(p_lngLoop)
         Case 93: xio_UDT.s93 = xi_astrArgs(p_lngLoop)
         Case 94: xio_UDT.s94 = xi_astrArgs(p_lngLoop)
         Case 95: xio_UDT.s95 = xi_astrArgs(p_lngLoop)
         Case 96: xio_UDT.s96 = xi_astrArgs(p_lngLoop)
         Case 97: xio_UDT.s97 = xi_astrArgs(p_lngLoop)
         Case 98: xio_UDT.s98 = xi_astrArgs(p_lngLoop)
         Case 99: xio_UDT.s99 = xi_astrArgs(p_lngLoop)
      End Select
   Next p_lngLoop
   
   
   ' ----------------------------------------------
   ' Set the return value
   ' ----------------------------------------------
   TranslateArray = p_lngCounter

End Function

' *******************************************************
' Routine Name : (PUBLIC in MODULE) Function FormatMsgFromResource
' Written By   : L.J  Johnson
' Programmer   : L.J  Johnson [Slightly Tilted Software]
' Date Writen  : 05/30/2001 -- 10:53:48
' Inputs       : ByVal xi_lngModuleHwnd:Long      - Module handle
'              : ByVal xi_lngEventID:Long         - Event ID to look up in module
'              : ByRef xi_typMsgs:FmtMsgArrayType - TYPE variable containing replaceable parameters
'              : ByRef xio_strMsg:String          - See OUTPUTS (below)
'              : ByRef xio_strApiError:String     - See OUTPUTS (below)
' Outputs      : LONG: Returns zero for success, error number otherwise
'              :     xio_strMsg      - Message from module with all parms replaced
'              :     xio_strApiError - API error msg
' Description  : Wrapper around the FormatMessage 32-bit API call
'              :
'              : Note - This is used to format a message from a
'              :     module, not from a string.  Some mods
'              :     would have to be made to format a string
'              :     with replaceable parameters.
'              :
'              : You *MUST* call TranslateArray to put the
'              :     replaceable parameters into a TYPE
'              :     variable before calling this function
' *******************************************************
Public Function FormatMsgFromResource(ByVal xi_lngModuleHwnd As Long, _
                                      ByVal xi_lngEventID As Long, _
                                      ByRef xi_typMsgs As FmtMsgArrayType, _
                                      ByRef xio_strMsg As String, _
                                      ByRef xio_strApiError As String, _
                                      Optional ByVal xi_blnRtnErrors As Boolean = True) As Long
   Dim p_lngFlags                      As Long
   Dim p_lngSize                       As Long
   Dim p_strMsg                        As String
   Dim p_lngRtn                        As Long

   ' ----------------------------------------
   ' Set the flags for the API call
   ' ----------------------------------------
   p_lngFlags = FORMAT_MESSAGE_FROM_HMODULE Or _
                FORMAT_MESSAGE_ARGUMENT_ARRAY
   p_lngSize = 10240
   p_strMsg = Space$(p_lngSize)

   ' ----------------------------------------
   ' Get the message string from the file
   ' ----------------------------------------
   p_lngRtn = FormatMessage(p_lngFlags, _
                            ByVal xi_lngModuleHwnd, _
                            xi_lngEventID, _
                            0&, _
                            p_strMsg, _
                            p_lngSize, _
                            xi_typMsgs)

   ' ----------------------------------------
   ' Check for errors
   ' ----------------------------------------
   If p_lngRtn = 0 Then
      xio_strMsg = vbNullString
      
      FormatMsgFromResource = (ERR_FAILED_FORMAT_MSG + vbObjectError)
      
      If xi_blnRtnErrors = True Then
         xio_strApiError = ReturnApiErrString(Err.LastDllError)
      Else
         xio_strApiError = vbNullString
      End If

   Else
      If xi_blnRtnErrors = True Then
         xio_strMsg = p_strMsg
         FormatMsgFromResource = 0
         xio_strApiError = vbNullString
      Else
         xio_strMsg = p_strMsg
         FormatMsgFromResource = 0
         xio_strApiError = vbNullString
      End If
   
   End If
   
End Function
