Option Explicit
On Error Resume Next
   Dim strPath
   Dim objWmiService
   Dim objLogFile
   Dim colLogFiles
   Dim errBackupLog
   Dim strErrMsg
   Dim strCommand	

   strCommand = WScript.Arguments(0)
   If strCommand = "" then
      strCommand = "."
   End If

   Set objWmiService = GetObject("winmgmts:" _
       & "{impersonationLevel=impersonate,(Backup,Security)}!\\" & _
        strCommand & "\root\cimv2")
   Set colLogFiles = objWmiService.ExecQuery("Select * from Win32_NTEventLogFile")
   
   For Each objLogFile In colLogFiles
      
      ' If the filename already exists, then
      ' the API call will fail (unless you
      ' first delete the file)
      strPath = "c:\" & _
                objLogFile.LogFileName & "_" & _
                GetCurrDate() & "_" & _
                GetCurrTime() & _
                ".evt"
      errBackupLog = objLogFile.BackupEventLog(strPath)

      If errBackupLog <> 0 Then
         strErrMsg = strErrMsg & "The " & objLogFile.LogFileName & _
                     " NT Event Log could not be backed up --" & "" & vbCrLf
      Else
         strErrMsg = strErrMsg & "The " & objLogFile.LogFileName & _
                     " NT Event Log was successfully backed up (" & strPath & ")." & vbCrLf
         ' Optional -- Clear the event log you 
         '             have successfully backed up
         'objLogFile.ClearEventLog()
      End If

   Next

   Wscript.Echo strErrMsg

Function GetCurrDate()
On Error Resume Next
   GetCurrDate = DatePart("yyyy", Now) & "-" & _
                 DatePart("m", Now) & "-" & _
                 DatePart("d", Now)
End Function

Function GetCurrTime()
On Error Resume Next
   GetCurrTime = DatePart("h", Now) & "-" & _
                 DatePart("n", Now) & "-" & _
                 DatePart("s", Now)
End Function
